package com.hai.dao;

import com.hai.entity.HighDiscountPackageAgentRel;
import com.hai.entity.HighDiscountPackageAgentRelExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighDiscountPackageAgentRelMapper extends HighDiscountPackageAgentRelMapperExt {
    @SelectProvider(type=HighDiscountPackageAgentRelSqlProvider.class, method="countByExample")
    long countByExample(HighDiscountPackageAgentRelExample example);

    @DeleteProvider(type=HighDiscountPackageAgentRelSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighDiscountPackageAgentRelExample example);

    @Delete({
        "delete from high_discount_package_agent_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_discount_package_agent_rel (discount_package_title, discount_package_id, ",
        "agent_name, agent_id, ",
        "stock_count, sales_count, ",
        "create_time, update_time, ",
        "`status`, op_id, op_name, ",
        "ext_1, ext_2, ext_3)",
        "values (#{discountPackageTitle,jdbcType=VARCHAR}, #{discountPackageId,jdbcType=BIGINT}, ",
        "#{agentName,jdbcType=VARCHAR}, #{agentId,jdbcType=BIGINT}, ",
        "#{stockCount,jdbcType=INTEGER}, #{salesCount,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{opId,jdbcType=BIGINT}, #{opName,jdbcType=VARCHAR}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighDiscountPackageAgentRel record);

    @InsertProvider(type=HighDiscountPackageAgentRelSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighDiscountPackageAgentRel record);

    @SelectProvider(type=HighDiscountPackageAgentRelSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_package_title", property="discountPackageTitle", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_package_id", property="discountPackageId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_name", property="agentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="stock_count", property="stockCount", jdbcType=JdbcType.INTEGER),
        @Result(column="sales_count", property="salesCount", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighDiscountPackageAgentRel> selectByExample(HighDiscountPackageAgentRelExample example);

    @Select({
        "select",
        "id, discount_package_title, discount_package_id, agent_name, agent_id, stock_count, ",
        "sales_count, create_time, update_time, `status`, op_id, op_name, ext_1, ext_2, ",
        "ext_3",
        "from high_discount_package_agent_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_package_title", property="discountPackageTitle", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_package_id", property="discountPackageId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_name", property="agentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="stock_count", property="stockCount", jdbcType=JdbcType.INTEGER),
        @Result(column="sales_count", property="salesCount", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighDiscountPackageAgentRel selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighDiscountPackageAgentRelSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighDiscountPackageAgentRel record, @Param("example") HighDiscountPackageAgentRelExample example);

    @UpdateProvider(type=HighDiscountPackageAgentRelSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighDiscountPackageAgentRel record, @Param("example") HighDiscountPackageAgentRelExample example);

    @UpdateProvider(type=HighDiscountPackageAgentRelSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighDiscountPackageAgentRel record);

    @Update({
        "update high_discount_package_agent_rel",
        "set discount_package_title = #{discountPackageTitle,jdbcType=VARCHAR},",
          "discount_package_id = #{discountPackageId,jdbcType=BIGINT},",
          "agent_name = #{agentName,jdbcType=VARCHAR},",
          "agent_id = #{agentId,jdbcType=BIGINT},",
          "stock_count = #{stockCount,jdbcType=INTEGER},",
          "sales_count = #{salesCount,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "op_id = #{opId,jdbcType=BIGINT},",
          "op_name = #{opName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighDiscountPackageAgentRel record);
}