package com.hai.goods.service;

import com.hai.entity.GoodsOrder;

import java.util.List;
import java.util.Map;

/**
 * @serviceName GoodsOrderService.java
 * @author Sum1Dream
 * @version 1.0.0
 * @Description // 商品订单业务
 * @createTime 17:52 2023/4/18
 **/
public interface GoodsOrderExtService {

    /**
     * @Author Sum1Dream
     * @Name insertGoodsOrder
     * @Description // 新增
     * @Date 15:08 2023/4/11
     * @Param [GoodsOrder]
     * @Return void
     */
    void insertGoodsOrder(GoodsOrder goodsOrder);

    /**
     * @Author Sum1Dream
     * @Name updateGoodsOrder
     * @Description // 更新
     * @Date 15:14 2023/4/11
     * @Param [GoodsOrder]
     * @Return void
     */
    void updateGoodsOrder(GoodsOrder goodsOrder);

    /**
     * @Author Sum1Dream
     * @Name getGoodsOrderList
     * @Description // 查询
     * @Date 15:17 2023/4/11
     * @Param [map]
     * @Return java.util.List<com.hai.entity.GoodsOrder>
     */
    List<GoodsOrder> getGoodsOrderList(Map<String , Object> map);


    /**
     * @Author Sum1Dream
     * @Name findGoodsOrderById
     * @Description // 根据id查询详情
     * @Date 16:19 2023/4/11
     * @Param [id]
     * @Return com.hai.entity.GoodsOrder
     */
    GoodsOrder findGoodsOrderById(Long id);

    /**
     * @Author Sum1Dream
     * @Name findGoodsOrder
     * @Description // 查询详情
     * @Date 15:44 2023/4/20
     * @Param [orderNo]
     * @Return com.hai.entity.GoodsOrder
     */
    GoodsOrder findGoodsOrder(String orderNo);

    /**
     * @Author Sum1Dream
     * @Name findGoodsOrderByLogisticsNo
     * @Description // 根据运单号查询订单
     * @Date 17:20 2023/4/20
     * @Param [logisticsNo]
     * @Return com.hai.entity.GoodsOrder
     */
    GoodsOrder findGoodsOrderByLogisticsNo(String logisticsNo);

    /**
     * @Author Sum1Dream
     * @Name deleteGoodsOrder
     * @Description // 删除
     * @Date 17:37 2023/4/13
     * @Param [id]
     * @Return void
     */
    void deleteGoodsOrder(Long id);
    
}
