package com.hai.group;

import com.alibaba.fastjson.JSONObject;
import com.hai.common.utils.HttpsUtils;
import com.hai.config.CommonSysConst;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;
@Component
public class GroupService {


    /**
    * @Author Sum1Dream
    * @Name getStoreList
    * @Description // 查询门店列表
    * @Date 11:24 2023/11/1
    * @Param params
     * @return com.alibaba.fastjson.JSONObject
    */
    public JSONObject getStoreList(JSONObject params) {
        return HttpsUtils.doPost(CommonSysConst.getSysConfig().getPayPostUrl() + "/openGroup/getStoreList" , params);
//        return HttpsUtils.doPost("http://localhost:9601/crest/openGroup/getStoreList" , params);
    }

    /**
    * @Author Sum1Dream
    * @Name getGroupContent
    * @Description // 查询团购内容
    * @Date 11:24 2023/11/1
    * @Param groupId
     * @return com.alibaba.fastjson.JSONObject
    */
    public JSONObject getGroupContent(Long groupId) {
        Map<String , Object> params = new HashMap<>();
        params.put("groupId" , groupId);
        return HttpsUtils.doGet(CommonSysConst.getSysConfig().getPayPostUrl() + "/openGroup/getGroupContent" , params);
    }

    /**
    * @Author Sum1Dream
    * @Name getStoreMsg
    * @Description // 查询门店信息
    * @Date 11:24 2023/11/1
    * @Param storeId
     * @return com.alibaba.fastjson.JSONObject
    */
    public JSONObject getStoreMsg(Long storeId) {
        Map<String , Object> params = new HashMap<>();
        params.put("storeId" , storeId);
        return HttpsUtils.doGet(CommonSysConst.getSysConfig().getPayPostUrl() + "/openGroup/getStoreMsg" , params);
    }

    /**
    * @Author Sum1Dream
    * @Name getMerNo
    * @Description // 获取商户号
    * @Date 15:27 2023/11/15
    * @Param storeId
     * @return com.alibaba.fastjson.JSONObject
    */
    public JSONObject getMerNo(Long storeId) {
        Map<String , Object> params = new HashMap<>();
        params.put("storeId" , storeId);
        return HttpsUtils.doGet(CommonSysConst.getSysConfig().getPayPostUrl() + "/openGroup/getMerNo" , params);
    }

    /**
    * @Author Sum1Dream
    * @Name getBsStoreImgByList
    * @Description // 门店查询图片
    * @Date 10:00 2023/11/2
    * @Param params
     * @return com.alibaba.fastjson.JSONObject
    */
    public JSONObject getBsStoreImgByList(JSONObject params) {
        return HttpsUtils.doPost(CommonSysConst.getSysConfig().getPayPostUrl() + "/openGroup/getBsStoreImgByList" , params);
    }






}
