package com.hai.openApi.service.impl;

import com.hai.dao.ApiBlxCouponMapper;
import com.hai.dao.ApiBlxOrderMapper;
import com.hai.entity.ApiBlxCoupon;
import com.hai.entity.ApiBlxCouponExample;
import com.hai.entity.ApiBlxOrder;
import com.hai.entity.ApiBlxOrderExample;
import com.hai.openApi.service.ApiBlxCouponService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;


import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Service("apiBlxCouponService")
public class ApiBlxCouponServiceImpl implements ApiBlxCouponService {

    @Resource
    private ApiBlxCouponMapper apiBlxCouponMapper;

    @Resource
    private ApiBlxOrderMapper apiBlxOrderMapper;

    @Override
    public void insertBlxCoupon(ApiBlxCoupon apiBlxCoupon) {
        apiBlxCouponMapper.insert(apiBlxCoupon);
    }

    @Override
    public void editBlxCoupon(ApiBlxCoupon apiBlxCoupon) {
        apiBlxCouponMapper.updateByPrimaryKey(apiBlxCoupon);
    }

    @Override
    public ApiBlxCoupon findBlxCoupon(String couponCode) {
        ApiBlxCouponExample example = new ApiBlxCouponExample();
        ApiBlxCouponExample.Criteria criteria = example.createCriteria();

        criteria.andCouponCodeEqualTo(couponCode);

        List<ApiBlxCoupon> apiBlxCoupons = apiBlxCouponMapper.selectByExample(example);

        if (apiBlxCoupons.size() > 0) {
            return apiBlxCoupons.get(0);
        }

        return null;
    }

    @Override
    public List<ApiBlxCoupon> getBlxCouponList(Map<String, Object> map) {

        ApiBlxCouponExample example = new ApiBlxCouponExample();
        ApiBlxCouponExample.Criteria criteria = example.createCriteria();

        criteria.andCouponStatusEqualTo(1);

        return apiBlxCouponMapper.selectByExample(example);
    }

    @Override
    public void insertBlxOrder(ApiBlxOrder apiBlxOrder) {
        apiBlxOrderMapper.insert(apiBlxOrder);
    }

    @Override
    public void editBlxOrder(ApiBlxOrder apiBlxOrder) {
        apiBlxOrderMapper.updateByPrimaryKey(apiBlxOrder);
    }

    @Override
    public ApiBlxOrder findOrderByMap(Map<String, Object> map) {

        ApiBlxOrderExample example = new ApiBlxOrderExample();
        ApiBlxOrderExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getString(map , "merId") != null) {
            criteria.andMerIdEqualTo(MapUtils.getString(map , "merId"));
        }
        if (MapUtils.getString(map , "orderNo") != null) {
            criteria.andOrderNoEqualTo(MapUtils.getString(map , "orderNo"));
        }
        if (MapUtils.getString(map , "merOrderId") != null) {
            criteria.andMerOrderIdEqualTo(MapUtils.getString(map , "merOrderId"));
        }
        if (MapUtils.getString(map , "parkOrderId") != null) {
            criteria.andParkOrderIdEqualTo(MapUtils.getString(map , "parkOrderId"));
        }
        if (MapUtils.getInteger(map , "status") != null) {
            criteria.andOrderStatusEqualTo(MapUtils.getInteger(map , "status"));
        }

        List<ApiBlxOrder> list = apiBlxOrderMapper.selectByExample(example);

        if (list.size() > 0 ) {
            return list.get(0);
        }

        return null;
    }

    @Override
    public List<ApiBlxOrder> getOrderByList(Map<String, Object> map) {
        ApiBlxOrderExample example = new ApiBlxOrderExample();
        ApiBlxOrderExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getString(map , "merId") != null) {
            criteria.andMerIdEqualTo(MapUtils.getString(map , "merId"));
        }
        if (MapUtils.getLong(map , "userId") != null) {
            criteria.andUserIdEqualTo(MapUtils.getLong(map , "userId"));
        }
        if (MapUtils.getString(map , "orderNo") != null) {
            criteria.andOrderNoEqualTo(MapUtils.getString(map , "orderNo"));
        }
        if (MapUtils.getString(map , "merOrderId") != null) {
            criteria.andMerOrderIdEqualTo(MapUtils.getString(map , "merOrderId"));
        }
        if (MapUtils.getString(map , "parkOrderId") != null) {
            criteria.andParkOrderIdEqualTo(MapUtils.getString(map , "parkOrderId"));
        }
        if (MapUtils.getInteger(map , "status") != null) {
            criteria.andOrderStatusEqualTo(MapUtils.getInteger(map , "status"));
        }

        return apiBlxOrderMapper.selectByExample(example);
    }
}
