package com.hai.order.model;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 订单退款模型
 * @className: ExportGasOrderModel
 * @author: 袁野
 * @date: 2022/10/28
 **/
@Data
public class ExportOrderModel {

    @ColumnWidth(25)
    @ExcelProperty("推广人")
    private String userName;

    @ColumnWidth(25)
    @ExcelProperty("标题")
    private String title;

    @ColumnWidth(15)
    @ExcelProperty("客户电话")
    private String memPhone;

    @ColumnWidth(25)
    @ExcelProperty("交易单号")
    private String orderNo;

    @ColumnWidth(13)
    @ExcelProperty(value = "应付金额")
    private BigDecimal payablePrice;

    @ColumnWidth(13)
    @ExcelProperty(value = "实付金额")
    private BigDecimal payPrice;

    @ColumnWidth(15)
    @ExcelProperty("创建时间")
    private Date createTime;

    @ColumnWidth(15)
    @ExcelProperty("支付时间")
    private Date payTime;

    @ColumnWidth(15)
    @ExcelProperty("完成时间")
    private Date finishTime;

    @ColumnWidth(15)
    @ExcelProperty("备注")
    private String remark;

}
